HTTP::Server::Response - Crystal 1.16.3

# class HTTP::Server::Response

- HTTP::Server::Response
- IO
- Reference
- Object

##
Overview

The response to configure and write to in an `HTTP::Server` handler.

The response `#status` and `#headers` must be configured before writing the response body. Once response output is written, changing the `#status` and `#headers` properties has no effect.

The `HTTP::Server::Response` is a write-only `IO`, so all `IO` methods are available in it.

A response can be upgraded with the `#upgrade` method. Once invoked, headers are written and the connection `IO` (a socket) is yielded to the given block. This is useful to implement protocol upgrades, such as websockets.

##
Defined in:

http/server/response.cr

##
Instance Method Summary

- #close : Nil

  Closes this response, writing headers and body if not done yet.

- #closed? : Bool

  Returns `true` if this response has been closed.

- #content_length=(content_length : Int)

  Convenience method to set the `Content-Length` header.

- #content_type=(content_type : String)

  Convenience method to set the `Content-Type` header.

- #cookies : HTTP::Cookies

  Convenience method to set cookies, see `HTTP::Cookies`.

- #flush : Nil

  Flushes the output.

- #headers : HTTP::Headers

  The response headers (`HTTP::Headers`).

- #output : IO

  The `IO` to which output is written.

- #output=(output : IO)

  The `IO` to which output is written.

- #redirect(location : String | URI, status : HTTP::Status = :found)

  Sends a redirect to location.

- #respond_with_status(status : HTTP::Status, message : String | Nil = nil) : Nil

  Sends status and message as response.

- #respond_with_status(status : Int, message : String | Nil = nil) : Nil

  Sends status and message as response.

- #status : HTTP::Status

  The status code of this response, which must be set before writing the response body.

- #status=(status : HTTP::Status)
- #status_code : Int32

  Convenience method to retrieve the HTTP status code.

- #status_code=(status_code : Int32)

  Convenience method to set the HTTP status code.

- #status_message : String | Nil

  Returns the status message.

- #status_message=(status_message : String | Nil)

  Sets the status message.

- #upgrade(&block : IO -> ) : Nil

  Upgrades this response, writing headers and yielding the connection `IO` (a socket) to the given block.

- #version : String

  The version of the HTTP::Request that created this response.

- #write(slice : Bytes) : Nil

  See `IO#write(slice)`.

### Instance methods inherited from class `IO`

<<(obj) : self <<, close close, closed? : Bool closed?, each_byte(&) : Nil
each_byte each_byte, each_char(&) : Nil
each_char each_char, each_line(*args, **options, &block : String -> ) : Nil
each_line(*args, **options) each_line, encoding : String encoding, flush flush, getb_to_end : Bytes getb_to_end, gets(limit : Int, chomp = false) : String | Nil
gets(delimiter : Char, limit : Int, chomp = false) : String | Nil
gets(delimiter : Char, chomp = false) : String | Nil
gets(delimiter : String, chomp = false) : String | Nil
gets(chomp = true) : String | Nil gets, gets_to_end : String gets_to_end, peek : Bytes | Nil peek, pos pos, pos=(value) pos=, print(obj : _) : Nil
print(*objects : _) : Nil print, printf(format_string, args : Array | Tuple) : Nil
printf(format_string, *args) : Nil printf, puts(string : String) : Nil
puts(obj : _) : Nil
puts : Nil
puts(*objects : _) : Nil puts, read(slice : Bytes) read, read_at(offset, bytesize, & : IO -> ) read_at, read_byte : UInt8 | Nil read_byte, read_bytes(type, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) read_bytes, read_char : Char | Nil read_char, read_fully(slice : Bytes) : Int32 read_fully, read_fully?(slice : Bytes) : Int32 | Nil read_fully?, read_line(*args, **options) : String read_line, read_string(bytesize : Int) : String read_string, read_utf8(slice : Bytes) read_utf8, read_utf8_byte : UInt8 | Nil read_utf8_byte, rewind rewind, seek(offset, whence : Seek = Seek::Set) seek, set_encoding(encoding : String, invalid : Symbol | Nil = nil) : Nil set_encoding, skip(bytes_count : Int) : Nil skip, skip_to_end : Nil skip_to_end, tell tell, tty? : Bool tty?, write(slice : Bytes) : Nil write, write_byte(byte : UInt8) : Nil write_byte, write_bytes(object, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) : Nil write_bytes, write_string(slice : Bytes) : Nil write_string, write_utf8(slice : Bytes) : Nil write_utf8

### Class methods inherited from class `IO`

copy(src, dst, limit : Int) : Int64
copy(src, dst) : Int64 copy, pipe(read_blocking = false, write_blocking = false) : Tuple(IO::FileDescriptor, IO::FileDescriptor)
pipe(read_blocking = false, write_blocking = false, &) pipe, same_content?(stream1 : IO, stream2 : IO) : Bool same_content?

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, initialize initialize, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference) : Bool
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new, unsafe_construct(address : Pointer, *args, **opts) : self unsafe_construct

### Class methods inherited from class `Reference`

pre_initialize(address : Pointer) pre_initialize

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Instance Method Detail

def close : Nil #

Closes this response, writing headers and body if not done yet. This method must be implemented if wrapping the response output.

def closed? : Bool #

Returns `true` if this response has been closed.

def content_length=(content_length : Int) #

Convenience method to set the `Content-Length` header.

def content_type=(content_type : String) #

Convenience method to set the `Content-Type` header.

def cookies : HTTP::Cookies #

Convenience method to set cookies, see `HTTP::Cookies`.

def flush : Nil #

Flushes the output. This method must be implemented if wrapping the response output.

def headers : HTTP::Headers #

The response headers (`HTTP::Headers`). These must be set before writing to the response.

def output : IO #

The `IO` to which output is written. This can be changed/wrapped to filter the response body (for example to compress the output).

def output=(output : IO) #

The `IO` to which output is written. This can be changed/wrapped to filter the response body (for example to compress the output).

def redirect(location : String | URI, status : HTTP::Status = :found) #

Sends a redirect to location.

The value of location gets encoded with `URI.encode`.

The status determines the HTTP status code which can be `HTTP::Status::FOUND` (`302`) for a temporary redirect or `HTTP::Status::MOVED_PERMANENTLY` (`301`) for a permanent redirect.

The response gets closed.

Raises `IO::Error` if the response is closed or headers were already sent.

def respond_with_status(status : HTTP::Status, message : String | Nil = nil) : Nil #

Sends status and message as response.

This method calls `#reset` to remove any previous settings and writes the given status and message to the response IO. Finally, it closes the response.

If message is `nil`, the default message for status is used provided by `HTTP::Status#description`.

Raises `IO::Error` if the response is closed or headers were already sent.

def respond_with_status(status : Int, message : String | Nil = nil) : Nil #

Sends status and message as response.

This method calls `#reset` to remove any previous settings and writes the given status and message to the response IO. Finally, it closes the response.

If message is `nil`, the default message for status is used provided by `HTTP::Status#description`.

Raises `IO::Error` if the response is closed or headers were already sent.

def status : HTTP::Status #

The status code of this response, which must be set before writing the response body. If not set, the default value is 200 (OK).

def status=(status : HTTP::Status) #
def status_code : Int32 #

Convenience method to retrieve the HTTP status code.

def status_code=(status_code : Int32) #

Convenience method to set the HTTP status code.

def status_message : String | Nil #

Returns the status message.

Defaults to description of `#status`.

def status_message=(status_message : String | Nil) #

Sets the status message.

def upgrade(&block : IO -> ) : Nil #

Upgrades this response, writing headers and yielding the connection `IO` (a socket) to the given block. This is useful to implement protocol upgrades, such as websockets.

def version : String #

The version of the HTTP::Request that created this response.

def write(slice : Bytes) : Nil #

See `IO#write(slice)`.